#!/bin/ksh
#
# 08/03/05 TR  Initial creation - Tony Rusho
#
# This script is meant to be run as root during the installation phase
# and generates the boot scripts for starting/stopping the agents
# 
# This is designed to be called from another script with $CANDLEHOME
# and $cArch already set
#

#
script_pream()
{
   print "#!/bin/ksh" > $1
   print "# (C) COPYRIGHT IBM, Inc. 2007" >> $1
   print "# Unpublished Work" >> $1
   print "# All Rights Reserved" >> $1
   print "# IBM/Tivoli Monitoring Version 6.2.0" >> $1

   
   return
}

script_pream_so()
{
   print "#!/bin/sh" > $1
   print "# (C) COPYRIGHT IBM, Inc. 2007" >> $1
   print "# Unpublished Work" >> $1
   print "# All Rights Reserved" >> $1
   print "# IBM/Tivoli Monitoring Version 6.2.0" >> $1

   
   return
}

  


  os=$(print $cArch|cut -c1-2)

  typeset filename
  filenum=1
 
#########################################################################################
#
# For LINUX systems symbolic links are created as follows
#
#         /etc/rc0.d/K10ITMAgents<#> ---> /etc/init.d/ITMAgents<#>
#         /etc/rc1.d/K10ITMAgents<#> ---> /etc/init.d/ITMAgents<#>
#         /etc/rc2.d/S99ITMAgents<#> ---> /etc/init.d/ITMAgents<#>
#         /etc/rc3.d/S99ITMAgents<#> ---> /etc/init.d/ITMAgents<#>
#         /etc/rc4.d/S99ITMAgents<#> ---> /etc/init.d/ITMAgents<#>
#         /etc/rc5.d/S99ITMAgents<#> ---> /etc/init.d/ITMAgents<#>
#         /etc/rc6.d/K10ITMAgents<#> ---> /etc/init.d/ITMAgents<#>
#
#
# For AIX systems following statement is written to the
# rc.itm<#> file in the /etc directory. (/etc/rc.itm<#>).
#              #!/bin/sh
#              # Added by install utility to start instance <#> of the 
#              # IBM/Tivoli Monitoring agents
#              #
#              if [ -f $CANDLEHOME/bin/CandleAgent ]; then
#                          $CANDLEHOME/bin/CandleAgent start all
#              fi
#              # End of add by install utility
#
#    The following line is added to /etc/inittab file after the entry for
#    rcnfs if present, or else after the line for rctcpip.
#
#    rcitm<#>:2:once:rc.itm<#> > /dev/console 2>&1 # IBM/Tivoli Monitoring Agents
#       - we use once because wait causes a hang when network is disconnected
#
# For HP systems symbolic links are created as follows
#
#         /sbin/rc0.d/K100ITMAgents<#> ---> /sbin/init.d/ITMAgents<#>
#         /sbin/rc1.d/K100ITMAgents<#> ---> /sbin/init.d/ITMAgents<#>
#         /sbin/rc2.d/S500ITMAgents<#> ---> /sbin/init.d/ITMAgents<#>
#
# For solaris systems symbolic links are created as follows
#
#         /etc/rc0.d/K10ITMAgents<#> ---> /etc/init.d/ITMAgents<#>
#         /etc/rc1.d/K10ITMAgents<#> ---> /etc/init.d/ITMAgents<#>
#         /etc/rc2.d/S99ITMAgents<#> ---> /etc/init.d/ITMAgents<#>
#

  if [[ "$os" = li || "$os" = lp || "$os" = lx ]]
  then 
     while [ -f /etc/init.d/ITMAgents$filenum ]
     do
       filenum=`expr $filenum + 1`
     done
  
     script_pream "/etc/init.d/ITMAgents$filenum"

     print "CANDLEHOME=$CANDLEHOME" >> /etc/init.d/ITMAgents$filenum
     print "export CANDLEHOME" >> /etc/init.d/ITMAgents$filenum
     cat $CANDLEHOME/bin/ITMAgents.sh >> /etc/init.d/ITMAgents$filenum
     chmod 755 /etc/init.d/ITMAgents$filenum

# defect 13635, SLES distributions don't have /etc/rcX.d directories
# they have /etc/init.d/rcX.d directories instead

     if [ -d /etc/rc0.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/rc0.d/K10ITMAgents$filenum
     fi
     if [ -d /etc/init.d/rc0.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/init.d/rc0.d/K10ITMAgents$filenum
     fi
     if [ -d /etc/rc1.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/rc1.d/K10ITMAgents$filenum
     fi
     if [ -d /etc/init.d/rc1.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/init.d/rc1.d/K10ITMAgents$filenum
     fi
     if [ -d /etc/rc2.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/rc2.d/S99ITMAgents$filenum
     fi
     if [ -d /etc/init.d/rc2.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/init.d/rc2.d/S99ITMAgents$filenum
     fi
     if [ -d /etc/rc3.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/rc3.d/S99ITMAgents$filenum
     fi
     if [ -d /etc/init.d/rc3.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/init.d/rc3.d/S99ITMAgents$filenum
     fi
     if [ -d /etc/rc4.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/rc4.d/S99ITMAgents$filenum
     fi
     if [ -d /etc/init.d/rc4.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/init.d/rc4.d/S99ITMAgents$filenum
     fi
     if [ -d /etc/rc5.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/rc5.d/S99ITMAgents$filenum
     fi
     if [ -d /etc/init.d/rc5.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/init.d/rc5.d/S99ITMAgents$filenum
     fi
     if [ -d /etc/rc6.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/rc6.d/K10ITMAgents$filenum
     fi
     if [ -d /etc/init.d/rc6.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/init.d/rc6.d/K10ITMAgents$filenum
     fi

     print $filenum > $CANDLEHOME/registry/AutoStart  # to identify the right script

     exit 0
  fi
  if [ "$os" = ls ]
  then 
     while [ -f /etc/init.d/ITMAgents$filenum ]
     do
       filenum=`expr $filenum + 1`
     done
  
     script_pream "/etc/init.d/ITMAgents$filenum"

     print "CANDLEHOME=$CANDLEHOME" >> /etc/init.d/ITMAgents$filenum
     print "export CANDLEHOME" >> /etc/init.d/ITMAgents$filenum
     cat $CANDLEHOME/bin/ITMAgents.sh >> /etc/init.d/ITMAgents$filenum
     chmod 755 /etc/init.d/ITMAgents$filenum

     if [ -d /etc/rc0.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/rc0.d/K10ITMAgents$filenum
     fi
     if [ -d /etc/init.d/rc0.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/init.d/rc0.d/K10ITMAgents$filenum
     fi
     if [ -d /etc/rc1.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/rc1.d/K10ITMAgents$filenum
     fi
     if [ -d /etc/init.d/rc1.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/init.d/rc1.d/K10ITMAgents$filenum
     fi
     if [ -d /etc/rc2.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/rc2.d/S99ITMAgents$filenum
     fi
     if [ -d /etc/init.d/rc2.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/init.d/rc2.d/S99ITMAgents$filenum
     fi
     if [ -d /etc/rc3.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/rc3.d/S99ITMAgents$filenum
     fi
     if [ -d /etc/init.d/rc3.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/init.d/rc3.d/S99ITMAgents$filenum
     fi
     if [ -d /etc/rc4.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/rc4.d/S99ITMAgents$filenum
     fi
     if [ -d /etc/init.d/rc4.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/init.d/rc4.d/S99ITMAgents$filenum
     fi
     if [ -d /etc/rc5.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/rc5.d/S99ITMAgents$filenum
     fi
     if [ -d /etc/init.d/rc5.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/init.d/rc5.d/S99ITMAgents$filenum
     fi
     if [ -d /etc/rc6.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/rc6.d/K10ITMAgents$filenum
     fi
     if [ -d /etc/init.d/rc6.d ]
     then
        ln -s /etc/init.d/ITMAgents$filenum /etc/init.d/rc6.d/K10ITMAgents$filenum
     fi

     print $filenum > $CANDLEHOME/registry/AutoStart  # to identify the right script
     exit 0
  fi

  if [ "$os" = hp ]
  then 
     while [ -f /sbin/init.d/ITMAgents$filenum ]
     do
       filenum=`expr $filenum + 1`
     done
  
     script_pream "/sbin/init.d/ITMAgents$filenum"

     print "CANDLEHOME=$CANDLEHOME" >> /sbin/init.d/ITMAgents$filenum
     print "export CANDLEHOME" >> /sbin/init.d/ITMAgents$filenum
     cat $CANDLEHOME/bin/ITMAgents.sh >> /sbin/init.d/ITMAgents$filenum
     chmod 755 /sbin/init.d/ITMAgents$filenum

     ln -s /sbin/init.d/ITMAgents$filenum /sbin/rc0.d/K100ITMAgents$filenum
     ln -s /sbin/init.d/ITMAgents$filenum /sbin/rc1.d/K100ITMAgents$filenum
     ln -s /sbin/init.d/ITMAgents$filenum /sbin/rc2.d/S500ITMAgents$filenum

     print $filenum > $CANDLEHOME/registry/AutoStart  # to identify the right script
     exit 0
  fi
  if [ "$os" = so ]
  then 
     while [ -f /etc/init.d/ITMAgents$filenum ]
     do
       filenum=`expr $filenum + 1`
     done
  
     script_pream_so "/etc/init.d/ITMAgents$filenum"

     print "CANDLEHOME=$CANDLEHOME" >> /etc/init.d/ITMAgents$filenum
     print "export CANDLEHOME" >> /etc/init.d/ITMAgents$filenum
     cat $CANDLEHOME/bin/ITMAgents.sh >> /etc/init.d/ITMAgents$filenum
     chmod 755 /etc/init.d/ITMAgents$filenum

     ln -s /etc/init.d/ITMAgents$filenum /etc/rc0.d/K10ITMAgents$filenum
     ln -s /etc/init.d/ITMAgents$filenum /etc/rc1.d/K10ITMAgents$filenum
     ln -s /etc/init.d/ITMAgents$filenum /etc/rc2.d/S99ITMAgents$filenum

     print $filenum > $CANDLEHOME/registry/AutoStart  # to identify the right script
     exit 0
  fi

  if [ "$os" = ai ]
  then 
     while [ -f /etc/rc.itm$filenum ]
     do
       filenum=`expr $filenum + 1`
     done
 
     script_pream "/etc/rc.itm$filenum"
     print "# Added by install utility to start instance <#> of the" >> /etc/rc.itm$filenum
     print "# IBM/Tivoli Monitoring agents" >> /etc/rc.itm$filenum
     print "#" >> /etc/rc.itm$filenum
     print "start_all()"  >> /etc/rc.itm$filenum
     print "{"  >> /etc/rc.itm$filenum
     print "}"  >> /etc/rc.itm$filenum
     print "##########"  >> /etc/rc.itm$filenum
     print "  if [ -f $CANDLEHOME/bin/CandleAgent ]" >> /etc/rc.itm$filenum 
     print "  then" >> /etc/rc.itm$filenum
     print "     start_all " >> /etc/rc.itm$filenum
     print "     $CANDLEHOME/bin/CandleAgent start all" >> /etc/rc.itm$filenum
     print "  fi" >> /etc/rc.itm$filenum
     chmod 755 /etc/rc.itm$filenum

     cp /etc/inittab /etc/inittab.itm$filenum    # save /etc/inittab off
     typeset -i vline=0
     vline=$(sed -n '/^rcnfs:/p' /etc/inittab | wc -l)
     if [ vline -gt 0 ]
     then
        mkitab -i rcnfs "rcitm$filenum:2:once:/etc/rc.itm$filenum > /dev/console 2>&1" # IBM/Tivoli Monitoring Agents
     else
         vline=$(sed -n '/^rctcpip:/p' /etc/inittab | wc -l)
         if [ vline -gt 0 ]
         then
            mkitab -i rctcpip "rcitm$filenum:2:once:/etc/rc.itm$filenum > /dev/console 2>&1" # IBM/Tivoli Monitoring Agents
         else
            mkitab "rcitm$filenum:2:once:/etc/rc.itm$filenum > /dev/console 2>&1" # IBM/Tivoli Monitoring Agents
         fi
     fi
  
     print $filenum > $CANDLEHOME/registry/AutoStart  # to identify the right script
     exit 0
  fi
  
